if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu"] = true;
dojo.require("com.ibm.mm.builder.widget.ShadowMenu");
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu", [dijit._Widget, dijit._Templated], {
	templateString: "<div class='actions_menu'><div dojoAttachPoint='_menuTextNode'><a href='javascript:;' role='button' aria-haspopup='true'>${I_SPACE_MANAGER_ACTIONS}</a></div></div>",
	
	spaceId: null,
	
	pageId: null,
	
	constructor: function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
	},
	
	postCreate: function() {
		this._menu = this._createMenu();
	},
	
	postMixInProperties: function() {
		dojo.mixin(this, this._bundle);
	},
	
	_createMenu: function() {
		var menu = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu.Menu({
			targetNodeIds: [this._menuTextNode],
			leftClickToOpen: true,
			spaceId: this.spaceId,
			pageId: this.pageId
		});
		
		dojo.addClass(menu.domNode, "spaceActionMenu");
		dojo.addClass(menu.domNode, "spaceManagerActionsMenu");
		
		menu.startup();
		return menu;
	},
	
	destroy: function() {
		this.inherited(arguments);
		
		dojo.forEach(this._menu.getChildren(), function(item){	
			this.removeChild(item);
			dijit.byId(item.id).destroy();
			item.destroyRecursive();		
			delete item;			
		},this._menu);

		this._menu.destroy();
	}
});


dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu.Menu", com.ibm.mm.builder.widget.ShadowMenu, {
	
		prepareData: function() {
			var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
			var widgetMenus = [];
			if (this.spaceId) {
				widgetMenus = mycontextmenu.getContextMenu("ContextMenu.SpaceManager.Space", this.spaceId, "space", null);
			} else if (this.pageId) {
				widgetMenus = mycontextmenu.getContextMenu("ContextMenu.SpaceManager.Page", this.pageId, "page", null);
			}
			for (var i = 0, n = widgetMenus.length; i < n; ++i) {
				if (widgetMenus[i].isSeparator) {
					this.addChild(new dijit.MenuSeparator());
					continue;
				}
				var mitem = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu.MenuItem({
					label: widgetMenus[i].title,
					iconClass: widgetMenus[i].iconClass,
					disabled: !widgetMenus[i].enabled,
					onClick: widgetMenus[i].actionCallBackFunction
				});
				this.addChild(mitem);
			}
		}
	});

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu.MenuItem",	dijit.MenuItem, {});

}
