if(!dojo._hasResource["com.ibm.mm.builder.dialog.DialogFooter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.DialogFooter"] = true;
dojo.provide("com.ibm.mm.builder.dialog.DialogFooter");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("com.ibm.mm.builder.dialog.DialogFooter",
	[dijit._Widget, dijit._Templated],
	{
		templateString: 
			'<div class="${baseClass}" role="region" aria-label="dialog footer">'+
			    '<input id="${saveId}" role="button" wairole="button" aria-label="${saveText}" title="${saveText}" type="button" class="${saveClass}" value="${saveText}" dojoAttachPoint="saveNode" dojoAttachEvent="onclick:onSave" accesskey="${saveAccessKey}"/>'+
				'<a id="${cancelId}" role="button" wairole="button" title="${cancelText}" aria-label="${cancelText}" class="${cancelClass}" href="JavaScript:void(0)" dojoAttachPoint="cancelNode" dojoAttachEvent="onclick:onCancel,onkeypress:_onCancelKeypress">${cancelText}</a>'+
			    //'<input id="${cancelId}" type="button" class="${cancelClass}" value="${cancelText}" dojoAttachPoint="cancelNode" dojoAttachEvent="onclick:onCancel,onkeypress:_onCancelKeypress" accesskey="${cancelAccessKey}"/>'+
		    '</div>',
		
		baseClass: "lotusDialogFooter",
		widgetId: "",
		IWID: "",
		
		saveId: "_${widgetId}_btn_save",
		saveClass: "lotusFormButton common_save",
		saveText: "${I_COMMON_SAVE}",
		saveAccessKey: "Q",
		
		cancelId: "_${widgetId}_cancel_text",
		cancelClass: "common_cancel lotusAction",
		cancelText: "${I_COMMON_CANCEL}",
		cancelAccessKey: "",
		
		resourceBundles: [com.ibm.mm.builder.coreWidgetsStrings],
		
		postMixInProperties: function() {
			this.inherited(arguments);
			if (this.IWID) {
				this.widgetId = this.IWID.substr(1, this.IWID.length - 2);
			}
			var smashedMixin = dojo.mixin.apply(dojo, [{}, this].concat(this.resourceBundles));
			dojo.forEach(["saveId", "saveText", "cancelId", "cancelText"], function(prop){
				this[prop] = dojo.string.substitute(this[prop], smashedMixin);
			}, this);
		},
		
		postCreate: function() {
			if (!this.cancelAccessKey) {
				this.cancelNode.removeAttribute("accesskey");
			}
			if (!this.saveAccessKey) {
				this.saveNode.removeAttribute("accesskey");
			}
			this.inherited(arguments);
		},
		
		_onSaveKeypress: function(e) {
			if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
				this.onSave(e);
			}
		},
		
		_onCancelKeypress: function(e) {
			if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
				this.onCancel(e);
			}
		},
		
		onSave: function(evt) {
			
		},
		onCancel: function(evt) {
			
		}
	}
);

}
