if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip"] = true;
/**
 * @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");

dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip", [dijit._Widget, dijit._Templated], {
	
	autoWiringResult: false,
	
	contentRoot: null,
	
	notificationDialog:null,
	
	widgetId: null,
	
	templateString: "<div dojoAttachPoint='autoWiringNotiDiv' class='mumAutoWiringTipDiv'>" +
						"<div class='mumAWDNIcon'>" + 
							"<img dojoAttachPoint='wiringIcon' />" +
						"</div>" + 
						"<div class='mumAWDNMiddle' >" + 
							"<div dojoAttachPoint='tipText' class='mumAWDNTip'>" + 
							"</div>" +
							"<div dojoAttachPoint='NotiCfgNode' class=''>" + 
								"<input type='checkbox' dojoAttachPoint='NotiCfgCheckNode' dojoAttachEvent='onclick: onNotNotifyMeClicked' class='mumAutoWiringNotiCfgCheck'/>" +
								"<div dojoAttachPoint='NotiCfgLabel' class='mumAutoWiringNotiCfgLable'></div>" +
							"</div>" +
						"</div>" +
						"<div dojoAttachPoint='okNode' class='mumAutoWiringOk'>" +
							"<div dojoAttachPoint='okTextHidden' class='mumAutoWiringOKTextHidden'>" + 
							"</div>"+
							"<div dojoAttachPoint='okText' class='mumAutoWiringOKText'>" + 
							"</div>"+
						"</div>" +
					"</div>",
						
	constructor:function(){
	},
	
	postCreate:function(){
		this.initContent();
	},
	
	updateContent:function(widgetId){
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(widgetId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		var tip = dojo.query(".mumAWDNTip", this.notificationDialog.domNode)[0];
		tip.innerHTML = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_INTERFACE_TIP,[widgetTitle,"<span class='mumAWDNTipLink'>","</span>"]);
		var link = dojo.query(".mumAWDNTipLink", tip)[0];
		dojo.connect(link,"onclick", this,"onClickOpenAWProperties");
		
		// check/uncheck the NotiCfgCheckNode
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")) {
    		var userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
	    	var user = userModel.findCurrentUser().start();
		    var showNoti = user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS");
		    this.NotiCfgCheckNode.checked = !showNoti;
		}
	},
	
	setOuterWirePaneContext:function(iContext) {
		this.outerContext = iContext;	
	},
	
	onNotNotifyMeClicked: function(event){
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")) {
    		var userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
	    	var user = userModel.findCurrentUser().start();
		    user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS",!this.NotiCfgCheckNode.checked);
		    userModel.commit().start();
		}
	},
	
	onClickOpenAWProperties:function(){
		this.hide();
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.outerContext.widgetId);
		com.ibm.mm.builder.commonActions.editPage(currentPageId);
	},
	
	initContent:function(){
		this.wiringIcon.alt = this.wiringIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME;			
		dojo.attr(this.wiringIcon,"src",builderConfig.builderPath + (builderConfig.isBidi ? "/images/d_wiring_icon_rtl.png" :
		"/images/d_wiring_icon.png"));
		this.NotiCfgLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_DISABLE_NOTI;
		this.okText.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
		dojo.connect(this.okText,"onclick", this,"hide");
		this.okTextHidden.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
		
		var contentDiv = document.createElement("div");
		contentDiv.appendChild(this.autoWiringNotiDiv);
		this.notificationDialog = dijit.byId("this.notificationDialog");
		if (!this.notificationDialog) {
			this.notificationDialog = new com.ibm.mm.builder.widget.CustomDialog({
				id: "Mashup_Auto_Wiring_Disable_Tip_Dlg",
				needUnderLay: false,
				roundCorner: true,
				modelDialog: true,
				hasRightBottomResizer: false,
				dialogOpacity: 0.85
			}, contentDiv);
		}
	},
	
	destroy:function() {
		this.notificationDialog.destroy();
	},
	
	show:function(widgetId) {
		this.updateContent(widgetId);
		this.notificationDialog.show();
	},
	
	hide:function(){
		if(this.notificationDialog) {
			this.notificationDialog.hide();
		}
	}
});

}
